﻿namespace Microsoft.ExternalResearch.CreativeCommons.Common
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// Represents a question for 'New license' wizard.
    /// </summary>
    internal class Question
    {
        /// <summary>
        /// ID of the question.
        /// </summary>
        private string id;

        /// <summary>
        /// Text of the question.
        /// </summary>
        private string label;

        /// <summary>
        /// Description of the question.
        /// </summary>
        private string description;

        /// <summary>
        /// Dictionary containing the options for the question.
        /// </summary>
        private Dictionary<string, string> options = new Dictionary<string, string>();

        /// <summary>
        /// Gets or sets the ID of the question.
        /// </summary>
        public string Id
        {
            get { return this.id; }
            set { this.id = value; }
        }

        /// <summary>
        /// Gets or sets the Label for the question.
        /// </summary>
        public string Label
        {
            get
            {
                return this.label;
            }

            set
            {
                this.label = value;
            }
        }

        /// <summary>
        /// Gets or sets the desccription for the question.
        /// </summary>
        public string Description
        {
            get { return this.description; }
            set { this.description = value; }
        }

        /// <summary>
        /// Gets the Options collection for the question.
        /// </summary>
        public IDictionary<string, string> Options
        {
            get { return this.options; }
        }
    }
}
